#ifndef __dxbutton_hpp__
#define __dxbutton_hpp__

#include <guichan.hpp>
#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
//#include <SDL/SDL_mixer.h>

/*
 * The ordinary default button is quite ugly so we have made ourselves
 * our own button be overloading Button. To make it simple we just
 * want our new button to show the caption, nothing more. If we have
 * a mouse hover we want the font to change which gives us a simple hover
 * effect.
 */
class DXButton : public gcn::Button
{
public:
	DXButton(const std::string& caption);
	DXButton(const std::string& caption, gcn::Font* hoverfont, gcn::Image* img);
	~DXButton();

	/* 
	 * Just sets the font to by used on mouse hover.
	 */
	void setHighLightFont(gcn::Font* font);
	
	void setImage(gcn::Image* img);
	/*
	 * Inherited from Widget
	 */
	void draw(gcn::Graphics* graphics);
	void mouseEntered(gcn::MouseEvent& mouseEvent);
	void mouseExited(gcn::MouseEvent& mouseEvent);
 
private:
	gcn::Font* mHighLightFont;
	gcn::Image* glyph;
	bool mHasMouse;
	// The sound (see SDL_mixer docs)
	//static Mix_Chunk* mHoverSound;
	// Keep track of instances to be able to free the sound
	//static int mInstances;
};

#endif
